1.题目:
nums1
中数字 x
的 下一个更大元素 是指 x
在 nums2
中对应位置 右侧 的 第一个 比 x
大的元素。
给你两个 没有重复元素 的数组 nums1
和 nums2
,下标从 0 开始计数,其中nums1
是 nums2
的子集。
对于每个 0 <= i < nums1.length
,找出满足 nums1[i] == nums2[j]
的下标 j
,并且在 nums2
确定 nums2[j]
的 下一个更大元素 。如果不存在下一个更大元素,那么本次查询的答案是 -1
。
返回一个长度为 nums1.length
的数组 ans
作为答案,满足 ans[i]
是如上所述的 下一个更大元素 。
2.示例:
示例 1:
输入:nums1 = [4,1,2], nums2 = [1,3,4,2]. 输出:[-1,3,-1] 解释:nums1 中每个值的下一个更大元素如下所述: - 4 ,用加粗斜体标识,nums2 = [1,3,4,2]。不存在下一个更大元素,所以答案是 -1 。 - 1 ,用加粗斜体标识,nums2 = [1,3,4,2]。下一个更大元素是 3 。 - 2 ,用加粗斜体标识,nums2 = [1,3,4,2]。不存在下一个更大元素,所以答案是 -1 。
示例 2:
输入:nums1 = [2,4], nums2 = [1,2,3,4]. 输出:[3,-1] 解释:nums1 中每个值的下一个更大元素如下所述: - 2 ,用加粗斜体标识,nums2 = [1,2,3,4]。下一个更大元素是 3 。 - 4 ,用加粗斜体标识,nums2 = [1,2,3,4]。不存在下一个更大元素,所以答案是 -1 。
3.提示:
1 <= nums1.length <= nums2.length <= 1000
0 <= nums1[i], nums2[i] <= 104
nums1
和nums2
中所有整数 互不相同
nums1
中的所有整数同样出现在 nums2
中
4.方法一:暴力
class Solution {public int[] nextGreaterElement(int[] nums1, int[] nums2) {int m = nums1.length, n = nums2.length;int[] res = new int[m];for (int i = 0; i < m; ++i) {int j = 0;while (j < n && nums2[j] != nums1[i]) {++j;}int k = j + 1;while (k < n && nums2[k] < nums2[j]) {++k;}res[i] = k < n ? nums2[k] : -1;}return res;}
}
5.方法2:单调栈:
package com.ffyc.leetcodetest;import java.util.Stack;public class nextGreaterElement496 {public int[] nextGreaterElement(int[] nums1, int[] nums2) {if(nums1==null||nums2==null){return null;}int []a=new int[nums2.length];//存入从后往前各个元素下一个给更大的元素Stack<Integer>stack=new Stack<>();for(int i=a.length-1;i>=0;i++){while(!stack.empty()&&stack.peek()<nums2[i]){stack.pop();}if(stack.empty()){a[i]=-1;}else{a[i]=stack.peek();}stack.push(nums2[i]);}int []b=new int[nums1.length];for(int i=0;i< nums1.length;i++){for(int j=0;j<nums2.length;j++){if(nums1[i]==nums2[j]){b[i]=a[j];}}}return b;}
}
6.二者对比
单调栈:
暴力:
相比这道题暴力解法相对好做,性能更高,不过单调栈作为一种思路还是最好了解一下;